static char CfgVirgoId[]="$Header: /cvsroot/Cfg/test/CfgVirgoBasic.c,v 1.1.1.45 2013/05/13 08:10:08 pacaud Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <CfgVirgo.h>
#include <pthread.h>
#include <unistd.h> 

int CfgStateSet( char * );

/*----------------------------------------------------------------------------*/
int CfgStateSet( char *state ) {

  /*--------------------------------------------------------------------------*/
  CfgMsgAddInfo("CfgStateSet> %s", state ?  state : "Undedined");
  /*--------------------------------------------------------------------------*/
  return(CFG_OK);
}

/*----------------------------------------------------------------------------*/
void CfgThread0( void ) {
  unsigned int loop;

  CfgMsgAddInfo("CfgThread0> started");
  /*--------------------------------------------------------------------------*/
  for( loop = 0; !CfgFinished(); loop++ ) {
    CfgMsgAddInfo("CfgThread0> loop %u", loop );
    usleep(500000);
  }
  CfgMsgAddInfo("CfgThread0> ended");
  /*--------------------------------------------------------------------------*/
  return;
}


/*----------------------------------------------------------------------------*/
void CfgThread1( void ) {
  unsigned int loop;
  CfgMsgAddInfo("CfgThread1> started");
  /*--------------------------------------------------------------------------*/
  for( loop = 0; !CfgFinished(); loop++ ) {
    CfgMsgAddInfo("CfgThread1> loop %u", loop );
    usleep(212121);
  }
  CfgMsgAddInfo("CfgThread1> ended");
  /*--------------------------------------------------------------------------*/
  return;
}


/*----------------------------------------------------------------------------*/
void CfgThread2( void ) {
  unsigned int loop;

  CfgMsgAddInfo("CfgThread2> started");
  /*--------------------------------------------------------------------------*/
  for( loop = 0; !CfgFinished(); loop++ ) {
    CfgMsgAddInfo("CfgThread2> loop %u", loop );
    usleep(333333);
    if( loop == 40 )  {
      CfgMsgAddFatal("CfgThread2> loop Fatal");
      break;
    }
  }
  CfgMsgAddInfo("CfgThread2> ended");
  /*--------------------------------------------------------------------------*/
  return;
}


/*----------------------------------------------------------------------------*/
void CfgVirgoExit( void ) {
  CfgMsgAddInfo("CfgVirgoExit> call");
}

/*----------------------------------------------------------------------------*/
/* char *CfgVirgoState( int state ) { */
/*   return(CfgServerStateStrGet()); */
/* } */

/*----------------------------------------------------------------------------*/
int main( int argc, char *argv[] ) {
  char liveTime[50];
  int i, lMsg, j;
  size_t size;
  char *config, *buf;
  pthread_t thread[3];

#ifdef USE_MW
  mwStatistics( 2 );
#endif
  if (CfgVirgoId);


  if( argc == 4 ) { lMsg = atoi( argv[2]  ); argc--; }
  else lMsg = 256;
  /*--------------------- Initialize Cm and Error Report ..., load the config */

  if( CfgIdle( argc, argv, lMsg ) == CFG_FAIL) exit(EXIT_FAILURE);
  CbfCleanSetExitFnt( CfgVirgoExit );
  CfgMsgAddInfo("Main> MailBox length %d", lMsg );
/*   CfgSetStateFnt( CfgServerIdle, CfgServerConfigured, */
/* 		  (CfgStateReachFnt_t)CfgStateSet, "IdleToConfigured" ); */
/*   CfgSetStateFnt( CfgServerConfigured, CfgServerActive, */
/* 		  (CfgStateReachFnt_t)CfgStateSet, "ConfiguredToActive" ); */
  CfgSetStateFnt( CfgServerIdle, CfgServerActive, 
		  (CfgStateReachFnt_t)CfgStateSet, "IdleToActive" );
  /*---------------- Define the function which define the server state string */
/*   CfgSetStateStrFnt(CfgVirgoState); */

  /*---------------------------------------------------Take the configuration */
  if( !(config = CfgGetConfig()) ) 
    CfgMsgAddFmt(CFG_FATAL, 0, "Config unknown" );
  printf("config> %s\n", config );
  
  /*---------------------------------------------------- Performs the parsing */
  CfgReachState( CfgServerConfigured ); 

#ifndef RIO806X
  pthread_create( &thread[0], NULL, (void *(*)(void*))CfgThread0, NULL );
  pthread_create( &thread[1], NULL, (void *(*)(void*))CfgThread1, NULL );
  pthread_create( &thread[2], NULL, (void *(*)(void*))CfgThread2, NULL );
#endif

  CfgReachState( CfgServerActive );
  
  CfgMsgSendWithTimeout(1.0);
  CfgLogFPrint( "Here> %s\n", CfgGetConfig() ? CfgGetConfig() : "NONE");

  CfgMsgPrintInfo("CfgMsgPrintInfo Call");
  CfgMsgPrintWarning("CfgMsgPrintWarning call");
 

  for( buf = NULL, size = 1024, i = 0; !CfgFinished(); i++ ) {
    for( j = 0; j < 2; j++ ) {
      CfgMsgAddInfo("Main> %d - %d", i, j);
      usleep(50000);
    }
 
   /*-------------------------------------------- Flush the message reporter */
    CfgMsgSendWithTimeout(1);
    CfgMsgAddFmt( CFG_INFO, 1, "Debug message" ); 
/*     if( i%10 == 0 )  */
/*       CfgMsgAddInfo("confTag %s - dbName %s", CfgData, */
/*                     (CfgData.dbName ? CfgData.dbName : "NONE") ); */
    /*------------------------------------------------------- Active Su State */
    CfgMsgAddUserInfo( "Active %s - size %f(KB)",  
		       CfgRunTimeStr( liveTime, sizeof liveTime),  size/1024.);

    if( (buf = (char*)realloc( buf, size )) ) size *= 2;
    if( i == 6 ) CfgMsgAddFatal("from main - %d", i);

  }
  if( buf ) { free(buf); buf = NULL; }

#ifndef RIO806X
  pthread_join( thread[0], NULL );
  pthread_join( thread[1], NULL );
  pthread_join( thread[2], NULL );
#endif
  exit(EXIT_SUCCESS);
}

